class ContainerGenerator < Rails::Generators::NamedBase
  source_root File.expand_path('../templates', __FILE__)
  argument :name, :type => :string, :default => "app"
  argument :install_folder_name, :type => :string, :default => "app"

	def create_directory
		empty_directory("app/javascript/src/#{install_folder_name}/containers/#{name}")
	end

	def create_container_files
		create_file "app/javascript/src/#{install_folder_name}/containers/#{name}/#{name}.js",
"import * as actions from './actions';
import * as constants from './constants';
import #{name}Reducer from './#{name}Reducer';

export default { actions, constants, #{name}Reducer };"
    create_file "app/javascript/src/#{install_folder_name}/containers/#{name}/actions.js",
"// import {} from './constants';
//import * as t from './actionTypes';

//export const someAction = (text) => ({
//	type: t.SOME_ACTION,
//	payload: { text }
//});"
    create_file "app/javascript/src/#{install_folder_name}/containers/#{name}/actionTypes.js",
"//export const SOME_ACTION = '#{name}/SOME_ACTION';"
    create_file "app/javascript/src/#{install_folder_name}/containers/#{name}/constants.js",
"// export const SOME_CONST = 'SOME_CONST';"

    create_file "app/javascript/src/#{install_folder_name}/containers/#{name}/#{name}Reducer.js",
"const #{name}Reducer = (state = {}, action) => {
  switch (action.type) {
    default:
  return state;
  }
};

export default #{name}Reducer;"
	end

  def add_namedReducer_to_reducer
    inject_into_file "app/javascript/src/#{install_folder_name}/reducer.js", "import #{name}Reducer from './containers/#{name}/#{name}Reducer.js'\n", :after => "import { combineReducers } from 'redux'\n"

    inject_into_file "app/javascript/src/#{install_folder_name}/reducer.js", "  #{name}Reducer,\n", :after => "const rootReducer = combineReducers({\n"
  end

end
